diff --git isisd/isis_trill.h isisd/isis_trill.h
new file mode 100644
index 0000000..88b9f83
--- /dev/null
+++ isisd/isis_trill.h
@@ -0,0 +1,148 @@
+/*
+ * IS-IS Rout(e)ing protocol - isis_trill.h
+ *
+ * Copyright (c) 2009, 2011, Oracle and/or its affiliates. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of the GNU General Public Licenseas published by the Free 
+ * Software Foundation; either version 2 of the License, or (at your option) 
+ * any later version.
+ *
+ * This program is distributed in the hope that it will be useful,but WITHOUT 
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
+ * more details.
+
+ * You should have received a copy of the GNU General Public License along 
+ * with this program; if not, write to the Free Software Foundation, Inc., 
+ * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ */
+
+#ifndef _ZEBRA_ISIS_TRILL_H
+#define _ZEBRA_ISIS_TRILL_H
+
+#define	ISO_BPDU	0x42
+
+/* IETF TRILL protocol defined constants */
+#define DFLT_NICK_PRIORITY 0x40			/* Default priority for autogen nicks */
+#define CONFIGURED_NICK_PRIORITY 0x80		/* MSB of priority set if nick is configured */
+#define MIN_RBRIDGE_PRIORITY 1			/* Min priority of use value */
+#define MAX_RBRIDGE_PRIORITY 127		/* Max priority of use value */
+#define MAX_RBRIDGE_NODES (RBRIDGE_NICKNAME_MAX + 1) /* Max RBridges possible */
+#define TRILL_NICKNAME_LEN   2			/* 16-bit nickname */
+#define TRILL_DFLT_ROOT_PRIORITY 0x8000		/* Default tree root priority */
+
+/* Constants used in nickname generation/allocation */
+#define NICKNAMES_BITARRAY_SIZE (MAX_RBRIDGE_NODES / 8) /* nick usage array */
+#define CLEAR_BITARRAY_ENTRYLEN 4	   /* stores nicks available per 32 nicks in nick bitarray */
+#define CLEAR_BITARRAY_ENTRYLENBITS (4*8)  /* 32 nicks tracked in each entry */
+#define CLEAR_BITARRAY_SIZE (MAX_RBRIDGE_NODES / CLEAR_BITARRAY_ENTRYLENBITS)
+
+/* Constants used to track LSP DB acquisition */
+#define MIN_LSPDB_ACQTRIES 2	/* min two LSP PSNP/CSNP send/recv for LSP DB acquisition */
+#define MAX_LSPDB_ACQTRIES 6	/* max LSP PSNP/CSNP send/recv for LSP DB acquisition on any circuit */
+
+/* Macros used to track LSP DB acquisition */
+#define LSPDB_ACQTRYINC(F, C) ((F)->trill->lspdb_acq_reqs[(C)])++
+#define LSPDB_ACQTRYVAL(F, C) ((F)->trill->lspdb_acq_reqs[(C)])
+
+/* trill_info status flags */
+#define TRILL_AUTONICK       (1 << 0)  /* nickname auto-generated (else user-provided) */
+#define TRILL_LSPDB_ACQUIRED (1 << 1)  /* LSP DB acquired before autogen nick is advertised */
+#define TRILL_NICK_SET       (1 << 2)  /* nickname configured (random/user generated) */
+#define TRILL_PRIORITY_SET   (1 << 3)  /* nickname priority configured by user */
+
+/* TRILL information (area-specific) */
+struct trill_info
+{
+  struct trill_nickname nick;   /* our nick */
+  int status; 			/* status flags */
+  dict_t *nickdb;	  	/* TRILL nickname database */
+  dict_t *sysidtonickdb;  	/* TRILL sysid-to-nickname database */
+  /* counter used in LSP database acquisition (per circuit) */
+  u_int8_t lspdb_acq_reqs [ISIS_MAX_CIRCUITS_COUNT];
+  struct list *fwdtbl;          /* RBridge forwarding table */
+  struct list *adjnodes;	/* Adjacent nicks for our distrib. tree */
+  struct list *dt_roots;	/* Our choice of DT roots */
+  struct list *vlans_reachable; /* Per adj and per tree vlans reachable downstream list */
+  u_int16_t root_priority;      /* Root tree priority */
+  char name[MAXLINKNAMELEN];	/* instance name */
+};
+
+/* TRILL nickname information (node-specific) */
+typedef struct nickinfo
+{
+  struct trill_nickname nick;       /* Nick of the node  */
+  u_char sysid[ISIS_SYS_ID_LEN];    /* NET/sysid of node */
+  u_int8_t flags;                   /* TRILL flags advertised by node */
+  struct list *dt_roots;            /* Distrib. Trees chosen by node */
+  u_int16_t root_priority;          /* Root tree priority */
+  u_int16_t root_count;		    /* Root tree count */
+  struct list *broots;		    /* VLANs and Bridge roots */
+  u_int8_t vlans_forwarder[VLANS_ARRSIZE];
+} nickinfo_t;
+
+/* Nickname database node */
+typedef struct trill_nickdb_node
+{
+  nickinfo_t info;		/* Nick info of the node */
+  struct isis_spftree *rdtree;  /* RBridge distribution tree with this nick as root */
+  struct list *adjnodes;	/* Our (host RBridge) adjacent nicks on this distrib. tree */
+  struct list *vlans_reachable; /* Per adj and per tree vlans reachable downstream list */
+  u_int32_t refcnt;		/* ref count */
+} nicknode_t;
+
+/* RBridge search function return status codes */
+typedef enum
+{
+  NOTFOUND = 1,
+  FOUND,
+  DUPLICATE,
+  NICK_CHANGED,
+  PRIORITY_CHANGE_ONLY
+} nickdb_search_result;
+
+/* LSP database acquisition process states */
+typedef enum
+{
+  CSNPRCV = 0,
+  CSNPSND,
+  PSNPSNDTRY,
+} lspdbacq_state;
+
+/* RBridge forwarding table node (1 table per area) */
+typedef struct nickfwdtable_node
+{
+  u_int16_t dest_nick;               /* destination RBridge nick */
+  u_char adj_snpa[ETH_ALEN];         /* MAC address of the adj node */
+  struct interface *interface;       /* if to reach the adj/neigh */
+} nickfwdtblnode_t;
+
+void trill_read_config (char **, int, char **);
+void trill_area_init(struct isis_area *);
+void trill_area_free(struct isis_area *);
+void trill_get_area_nickinfo(struct isis_area *, struct trill_nickname *);
+void trill_nickdb_print (struct vty *, struct isis_area *);
+void trill_nick_destroy(struct isis_lsp *);
+void trill_lspdb_acquire_event(struct isis_circuit *, lspdbacq_state);
+int trill_area_nickname(struct isis_area *, u_int16_t);
+void trill_parse_router_capability_tlvs (struct isis_area *, struct isis_lsp *);
+void trill_process_spf (struct isis_area *);
+void trill_process_hello(struct isis_adjacency *, struct list *);
+void send_trill_vlan_hellos(struct isis_circuit *);
+void trill_circuits_print_all (struct vty *, struct isis_area *);
+u_char *nick_to_sysid(struct isis_area *, u_int16_t); 
+u_int16_t sysid_to_nick(struct isis_area *, u_char *);
+void trill_create_vlanfilterlist(struct isis_area *, nicknode_t *);
+nicknode_t * trill_nicknode_lookup(struct isis_area *, uint16_t);
+void install_trill_elements (void);
+void install_trill_vlan_elements (void);
+int trill_process_bpdu (struct isis_circuit *, u_char *);
+int trill_send_bpdu (struct isis_circuit *circuit, const void *, size_t);
+void trill_send_tc_bpdus (struct isis_circuit *);
+void trill_set_vlan_forwarder (struct isis_circuit *, u_int8_t *);
+void trill_port_flush (struct isis_circuit *, u_int16_t);
+void trill_nick_flush (struct isis_circuit *, u_int16_t);
+void trill_inhib_all(struct isis_circuit *);
+char trill_reload(void);
+#endif
diff --git isisd/isis_trillbpdu.c isisd/isis_trillbpdu.c
new file mode 100644
index 0000000..2352cfc
--- /dev/null
+++ isisd/isis_trillbpdu.c
@@ -0,0 +1,202 @@
+/*
+ * TRILL BPDU handling - isis_trillbpdu.c
+ *
+ * Copyright (c) 2009, 2011, Oracle and/or its affiliates. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of the GNU General Public Licenseas published by the Free 
+ * Software Foundation; either version 2 of the License, or (at your option) 
+ * any later version.
+ *
+ * This program is distributed in the hope that it will be useful,but WITHOUT 
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
+ * more details.
+
+ * You should have received a copy of the GNU General Public License along 
+ * with this program; if not, write to the Free Software Foundation, Inc., 
+ * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ */
+#include <zebra.h>
+#include <time.h>
+#include "log.h"
+#include "if.h"
+#include "stream.h"
+#include "vty.h"
+#include "dict.h"
+#include "isis_common.h"
+#include "isis_constants.h"
+#include "isis_circuit.h"
+#include "isis_tlv.h"
+#include "isis_flags.h"
+#include "isis_vlans.h"
+#include "isis_lsp.h"
+#include "isis_trill.h"
+#include "isisd.h"
+
+/*
+ * This module supports just the bare minimum of Bridge PDU handling necessary
+ * for normal TRILL interaction with standard bridges.  It does not include
+ * spanning tree or other BPDU functions.
+ */
+
+struct common_bpdu
+{
+  u_int16_t cmb_protid;		/* Protocol Identifier */
+  u_int8_t cmb_protvers;	/* Protocol Version Identifier */
+  u_int8_t cmb_type;		/* BPDU Type */
+};
+
+#ifdef __SUNPRO_C
+#pragma pack(1)
+#endif
+
+struct conf_bpdu
+{
+  struct common_bpdu cb_cmb;
+  u_int8_t cb_flags;		/* BPDU Flags */
+  u_int8_t cb_rootid[8];	/* Root Identifier */
+  u_int8_t cb_unused[14];	/* Root Path Cost, Bridge ID, Port ID */
+  u_int16_t cb_messageage;	/* Message Age */
+  u_int16_t cb_maxage;		/* Max Age */
+  u_int16_t cb_hello;		/* Hello Time */
+  u_int16_t cb_unused2;		/* Forward Delay */
+} __attribute__ ((packed));
+
+#ifdef __SUNPRO_C
+#pragma pack()
+#endif
+
+#define	BPDU_PROTID		0	/* Standard STP and RSTP */
+#define	BPDU_PROTVERS_STP	0	/* STP */
+#define	BPDU_PROTVERS_RSTP	2	/* RSTP */
+#define	BPDU_FLAGS_TC_ACK	0x80
+#define	BPDU_FLAGS_TC		1
+#define	BPDU_TYPE_CONF		0
+#define	BPDU_TYPE_RCONF		2
+#define	BPDU_TYPE_TCNOTIF	0x80
+
+int
+trill_process_bpdu (struct isis_circuit *circuit, u_char *srcaddr)
+{
+  size_t bpdulen;
+  struct conf_bpdu cb;
+  time_t now;
+  int brcmp;
+
+  /*
+   * Standard BPDU validation first.  Unrecognized things are just returned
+   * silently.  Bad things (protocol violations) generate warnings.
+   */
+  bpdulen = stream_get_endp (circuit->rcv_stream);
+  if (bpdulen < sizeof (cb.cb_cmb))
+    return ISIS_WARNING;
+
+  stream_get (&cb.cb_cmb, circuit->rcv_stream, sizeof (cb.cb_cmb));
+  if (ntohs(cb.cb_cmb.cmb_protid) != BPDU_PROTID)
+    return ISIS_OK;
+
+  switch (cb.cb_cmb.cmb_type)
+  {
+    case BPDU_TYPE_CONF:
+      if (bpdulen < sizeof (cb))
+	return ISIS_WARNING;
+      stream_get (&cb.cb_cmb + 1, circuit->rcv_stream,
+	  sizeof (cb) - sizeof (cb.cb_cmb));
+      if (ntohs(cb.cb_messageage) >= ntohs(cb.cb_maxage))
+	return ISIS_WARNING;
+      /*
+       * We don't send Configuration BPDUs, so no need to check Bridge & Port
+       * ID values.
+       */
+      break;
+    case BPDU_TYPE_RCONF:
+      if (bpdulen < sizeof (cb) + 1)
+	return ISIS_WARNING;
+      stream_get (&cb.cb_cmb + 1, circuit->rcv_stream,
+	  sizeof (cb) - sizeof (cb.cb_cmb));
+      break;
+    case BPDU_TYPE_TCNOTIF:
+      return ISIS_OK;
+    default:
+      return ISIS_WARNING;
+  }
+
+  brcmp = memcmp (cb.cb_rootid, circuit->root_bridge, sizeof (cb.cb_rootid));
+  now = time (NULL);
+  if (circuit->root_expire == 0 || now - circuit->root_expire > 0 || brcmp <= 0)
+    {
+      int hellot;
+
+      hellot = ntohs(cb.cb_hello) / 256;
+      if (hellot < 1)
+	hellot = 1;
+      else if (hellot > 10)
+	hellot = 10;
+      circuit->root_expire = now + 3 * hellot;
+      memcpy(circuit->root_bridge, cb.cb_rootid, sizeof (cb.cb_rootid));
+
+      /* If root bridge change, then inhibit for a while */
+      if (brcmp != 0)
+	trill_inhib_all (circuit);
+
+     /*
+      * If we've gotten a Topology Change Ack from the root bridge, then we
+      * need not send any more TC notifications.
+      */
+      if ((cb.cb_flags & BPDU_FLAGS_TC) && circuit->tc_count != 0)
+	{
+	  thread_cancel (circuit->tc_thread);
+	  circuit->tc_thread = NULL;
+	  circuit->tc_count = 0;
+	}
+    }
+
+  return ISIS_OK;
+}
+
+/*
+ * Handle TC notification expiry: send another TC BPDU, up to a hard-coded
+ * limit.
+ */
+static int
+trill_send_tc (struct thread *thread)
+{
+  struct isis_circuit *circuit;
+  struct common_bpdu cmb;
+  int retv;
+
+  circuit = THREAD_ARG (thread);
+
+  cmb.cmb_protid = htons (BPDU_PROTID);
+  cmb.cmb_protvers = BPDU_PROTVERS_STP;
+  cmb.cmb_type = BPDU_TYPE_TCNOTIF;
+
+  retv = trill_send_bpdu (circuit, &cmb, sizeof (cmb));
+  if (retv != ISIS_OK)
+    zlog_warn ("TRILL unable to send TC BPDU on %s", circuit->interface->name);
+
+  if (++circuit->tc_count <= 5)
+    {
+      circuit->tc_thread = thread_add_timer (master, trill_send_tc, circuit, 1);
+    }
+  else
+    {
+      circuit->tc_thread = NULL;
+      circuit->tc_count = 0;
+    }
+
+  return retv;
+}
+
+/*
+ * Begin sending TC notification BPDUs on this circuit.  Transmissions are sent
+ * once a second until either 5 have been sent, or we receive a TC Ack from the
+ * root bridge.
+ */
+void
+trill_send_tc_bpdus (struct isis_circuit *circuit)
+{
+  circuit->tc_count = 1;
+  THREAD_TIMER_ON (master, circuit->tc_thread, trill_send_tc, circuit, 1);
+}
diff --git isisd/isis_trilldummy.c isisd/isis_trilldummy.c
new file mode 100644
index 0000000..edaeec3
--- /dev/null
+++ isisd/isis_trilldummy.c
@@ -0,0 +1,54 @@
+/*
+ * IS-IS Rout(e)ing protocol - isis_trilldummy.c
+ *
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of the GNU General Public Licenseas published by the Free 
+ * Software Foundation; either version 2 of the License, or (at your option) 
+ * any later version.
+ *
+ * This program is distributed in the hope that it will be useful,but WITHOUT 
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
+ * more details.
+
+ * You should have received a copy of the GNU General Public License along 
+ * with this program; if not, write to the Free Software Foundation, Inc., 
+ * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ */
+
+#include <zebra.h>
+#include <vty.h>
+#include <if.h>
+
+#include "dict.h"
+#include "bool.h"
+#include "isis_constants.h"
+#include "isis_common.h"
+#include "isis_flags.h"
+#include "isisd.h"
+#include "isis_adjacency.h"
+#include "isis_circuit.h"
+#include "isis_tlv.h"
+#include "isis_lsp.h"
+#include "isis_vlans.h"
+#include "isis_trill.h"
+
+void trill_read_config (char **cfilep, int argc, char **argv) { }
+void trill_process_hello(struct isis_adjacency *adj, struct list *portcaps) { }
+void trill_nickdb_print (struct vty *vty, struct isis_area *area) { }
+void trill_lspdb_acquire_event(struct isis_circuit *circuit,
+    lspdbacq_state caller) { }
+void trill_nick_destroy(struct isis_lsp *lsp) { }
+void send_trill_vlan_hellos(struct isis_circuit *circuit) { }
+void trill_area_init(struct isis_area *area) { }
+void trill_area_free(struct isis_area *area) { }
+void trill_parse_router_capability_tlvs (struct isis_area *area,
+    struct isis_lsp *lsp) { }
+void trill_process_spf (struct isis_area *area) { }
+int tlv_add_trill_nickname(struct trill_nickname *nick_info,
+    struct stream *stream, struct isis_area *area) { return ISIS_OK; }
+int tlv_add_trill_vlans(struct isis_circuit *circuit) { return ISIS_OK; }
+void install_trill_elements (void) { }
+void install_trill_vlan_elements (void) { }
+int trill_process_bpdu (struct isis_circuit *c, u_char *sa) { return ISIS_OK; }
+char trill_reload(void) { return FALSE; }
diff --git isisd/isis_trillio.c isisd/isis_trillio.c
new file mode 100644
index 0000000..858ba1e
--- /dev/null
+++ isisd/isis_trillio.c
@@ -0,0 +1,301 @@
+/*
+ * IS-IS Rout(e)ing protocol - isis_trillio.c
+ *
+ * Copyright (C) 2001,2002    Sampo Saaristo
+ *                            Tampere University of Technology      
+ *                            Institute of Communications Engineering
+ *
+ * Copyright (c) 2009, 2011, Oracle and/or its affiliates. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of the GNU General Public Licenseas published by the Free 
+ * Software Foundation; either version 2 of the License, or (at your option) 
+ * any later version.
+ *
+ * This program is distributed in the hope that it will be useful,but WITHOUT 
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
+ * more details.
+
+ * You should have received a copy of the GNU General Public License along 
+ * with this program; if not, write to the Free Software Foundation, Inc., 
+ * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ */
+
+#include <zebra.h>
+#include <net/if_dl.h>
+#include <sys/socket.h>
+#include <sys/stropts.h>
+#include <sys/ethernet.h>
+#include <net/trill.h>
+#include <net/bridge.h>
+
+#include "log.h"
+#include "stream.h"
+#include "network.h"
+#include "if.h"
+#include "vty.h"
+
+#include "isisd/dict.h"
+#include "isisd/include-netbsd/iso.h"
+#include "isisd/isis_constants.h"
+#include "isisd/isis_common.h"
+#include "isisd/isis_circuit.h"
+#include "isisd/isis_flags.h"
+#include "isisd/isisd.h"
+#include "isisd/isis_constants.h"
+#include "isisd/isis_circuit.h"
+#include "isisd/isis_network.h"
+#include "isisd/isis_tlv.h"
+#include "isisd/isis_lsp.h"
+#include "isisd/isis_vlans.h"
+#include "isisd/isis_trill.h"
+
+#include "privs.h"
+
+extern struct zebra_privs_t isisd_privs;
+
+static u_char sock_buff[32000];
+
+static const uint8_t all_isis_rbridges[] = ALL_ISIS_RBRIDGES;
+static const uint8_t bridge_group_address[] = BRIDGE_GROUP_ADDRESS;
+
+static int
+open_trill_socket (struct isis_circuit *circuit)
+{
+  struct sockaddr_dl laddr;
+  int fd;
+  unsigned int mtu;
+
+  circuit->fd = -1;
+
+  fd = socket (PF_TRILL, SOCK_DGRAM, 0);
+  if (fd < 0)
+    {
+      zlog_warn ("open_trill_socket(): socket() failed %s",
+		 safe_strerror (errno));
+      return ISIS_ERROR;
+    }
+
+  if (set_nonblocking (fd) < 0)
+    {
+      zlog_warn ("open_trill_socket(): set_nonblocking() failed: %s",
+	  safe_strerror (errno));
+      close (fd);
+      return ISIS_ERROR;
+    }
+
+  if (ioctl (fd, TRILL_NEWBRIDGE, &circuit->area->trill->name) < 0)
+    {
+      zlog_warn ("open_trill_socket(): TRILL_NEWBRIDGE ioctl failed: %s",
+	  safe_strerror (errno));
+      close (fd);
+      return ISIS_ERROR;
+    }
+
+  /*
+   * Bind to the physical interface that must be one of the 
+   * links in the bridge instance.
+   */
+  memset (&laddr, 0, sizeof (struct sockaddr_dl));
+  laddr.sdl_family = AF_TRILL;
+  laddr.sdl_nlen = sizeof (datalink_id_t);
+  *(datalink_id_t *)laddr.sdl_data = circuit->interface->ifindex;
+
+  if (bind (fd, (struct sockaddr *) (&laddr), sizeof (struct sockaddr_dl)) < 0)
+    {
+      zlog_warn ("open_trill_socket(): bind() failed: %s",
+	  safe_strerror (errno));
+      close (fd);
+      return ISIS_ERROR;
+    }
+
+  if (ioctl (fd, TRILL_HWADDR, &circuit->u.bc.snpa) < 0)
+    {
+      zlog_warn ("open_trill_socket(): TRILL_HWADDR ioctl failed: %s",
+	  safe_strerror (errno));
+      close (fd);
+      return ISIS_ERROR;
+    }
+
+  if (ioctl (fd, TRILL_GETMTU, &mtu) < 0)
+    zlog_warn ("open_trill_socket(): TRILL_GETMTU ioctl failed: %s",
+	safe_strerror (errno));
+  else
+    circuit->interface->mtu = mtu;
+
+  if (mtu > sizeof (sock_buff))
+    zlog_err ("open_trill_socket(): interface mtu:%d is greater than "
+        " sock_buff size:%d", mtu, sizeof (sock_buff));
+
+  circuit->fd = fd;
+
+  return ISIS_OK;
+}
+
+/*
+ * Create the socket and set the tx/rx funcs
+ */
+int
+isis_sock_init (struct isis_circuit *circuit)
+{
+  int retval;
+
+  if (isisd_privs.change (ZPRIVS_RAISE))
+    zlog_err ("%s: could not raise privs, %s", __func__, safe_strerror (errno));
+
+  circuit->tx = isis_send_pdu_bcast;
+  circuit->rx = isis_recv_pdu_bcast;
+
+  retval = open_trill_socket (circuit);
+
+  if (retval != ISIS_OK)
+    {
+      zlog_warn ("%s: could not initialize the socket", __func__);
+      goto end;
+    }
+
+  if (circuit->circ_type == CIRCUIT_T_P2P)
+    {
+      retval = ISIS_ERROR;
+      zlog_err ("%s: do not support P2P link ", __func__);
+    }
+  else if (circuit->circ_type != CIRCUIT_T_BROADCAST)
+    {
+      zlog_warn ("%s: unknown circuit type", __func__);
+      retval = ISIS_WARNING;
+    }
+
+end:
+  if (isisd_privs.change (ZPRIVS_LOWER))
+    zlog_err ("%s: could not lower privs, %s", __func__, safe_strerror (errno));
+
+  return retval;
+}
+
+int
+isis_recv_pdu_bcast (struct isis_circuit *circuit, u_char * ssnpa)
+{
+  int bytesread, addr_len;
+  struct sockaddr_dl laddr;
+  char *llsaddr;
+  uint16_t tci;
+  uint8_t sap;
+
+  if (circuit->fd == -1)
+    return ISIS_ERROR;
+
+  /* we have to read to the static buff first */
+  addr_len = sizeof (struct sockaddr_dl);
+  bytesread = recvfrom (circuit->fd, sock_buff, sizeof (sock_buff),
+			MSG_DONTWAIT, (struct sockaddr *) &laddr,
+			(socklen_t *) &addr_len);
+
+  if (bytesread < 0 && errno == EWOULDBLOCK)
+    return ISIS_WARNING;
+
+  if (laddr.sdl_slen != sizeof (tci) || laddr.sdl_alen != ETHERADDRL)
+    return ISIS_ERROR;
+
+  if (bytesread < LLC_LEN)
+    return ISIS_WARNING;
+
+  llsaddr = LLADDR(&laddr);
+  memcpy (ssnpa, llsaddr, laddr.sdl_alen);
+  tci = *(uint16_t *)(llsaddr + laddr.sdl_alen);
+
+  sap = tci == TRILL_TCI_BPDU ? ISO_BPDU : ISO_SAP;
+
+  if (sock_buff[0] != sap || sock_buff[1] != sap || sock_buff[2] != 0x03)
+    return ISIS_WARNING;
+
+  circuit->vlans->rx_tci = tci;
+  stream_write (circuit->rcv_stream, sock_buff + LLC_LEN, bytesread - LLC_LEN);
+
+  return ISIS_OK;
+}
+
+int
+isis_send_pdu_bcast (struct isis_circuit *circuit, int level)
+{
+  ssize_t written;
+  size_t msglen;
+  struct sockaddr_dl laddr;
+  char *dp;
+
+  if (circuit->fd == -1)
+    return ISIS_ERROR;
+
+  stream_set_getp (circuit->snd_stream, 0);
+
+  laddr.sdl_family = AF_TRILL;
+  dp = laddr.sdl_data;
+
+  laddr.sdl_nlen = sizeof (datalink_id_t);
+  memcpy (dp, &circuit->interface->ifindex, sizeof (datalink_id_t));
+  dp += laddr.sdl_nlen;
+
+  laddr.sdl_alen = ETHERADDRL;
+  memcpy (dp, all_isis_rbridges, laddr.sdl_alen);
+  dp += laddr.sdl_alen;
+
+  laddr.sdl_slen = sizeof (circuit->vlans->tx_tci);
+  memcpy (dp, &circuit->vlans->tx_tci, laddr.sdl_slen);
+
+  /* now set up the data in the buffer */
+  sock_buff[0] = ISO_SAP;
+  sock_buff[1] = ISO_SAP;
+  sock_buff[2] = 0x03;
+  msglen = stream_get_endp (circuit->snd_stream);
+  if (msglen + LLC_LEN > sizeof (sock_buff))
+    return ISIS_WARNING;
+  stream_get (sock_buff + LLC_LEN, circuit->snd_stream, msglen);
+  msglen += LLC_LEN;
+
+  /* now we can send this */
+  written = sendto (circuit->fd, sock_buff, msglen, 0,
+		    (struct sockaddr *) &laddr, sizeof (struct sockaddr_dl));
+
+  if (written != (ssize_t)msglen)
+    return ISIS_WARNING;
+
+  return ISIS_OK;
+}
+
+int
+trill_send_bpdu (struct isis_circuit *circuit, const void *msg, size_t msglen)
+{
+  ssize_t written;
+  struct sockaddr_dl laddr;
+  char *dp;
+
+  if (circuit->fd == -1)
+    return ISIS_ERROR;
+
+  /* add in the LLC header */
+  sock_buff[0] = ISO_BPDU;
+  sock_buff[1] = ISO_BPDU;
+  sock_buff[2] = 0x03;
+  memcpy (sock_buff + 3, msg, msglen);
+  msglen += 3;
+
+  laddr.sdl_family = AF_TRILL;
+  dp = laddr.sdl_data;
+
+  laddr.sdl_nlen = sizeof (datalink_id_t);
+  memcpy (dp, &circuit->interface->ifindex, sizeof (datalink_id_t));
+  dp += laddr.sdl_nlen;
+
+  laddr.sdl_alen = ETHERADDRL;
+  memcpy (dp, bridge_group_address, laddr.sdl_alen);
+
+  laddr.sdl_slen = 0;
+
+  written = sendto (circuit->fd, sock_buff, msglen, 0,
+		    (struct sockaddr *) &laddr, sizeof (struct sockaddr_dl));
+
+  if (written != (ssize_t)msglen)
+    return ISIS_WARNING;
+
+  return ISIS_OK;
+}
